using System;
using System.Collections.Generic;
using ModelInterfaces;

namespace Funktioner
{
	// definition af "Hoved-programmet" (data og metoder der findes i hovedprogrammet)
	public class VareFunktioner
	{
		// metode der opretter test varer
        public static void OpretTestVarer(IVarekatalog varekatalog)
		{
            IVare v1 = varekatalog.OpretVare(1001, "Sm", 0, 1.4f);
            v1.RegistrerVarerIndkbt(101, 20111001, 0.51f);
            v1.RegistrerVarerSolgt(1, 20111001, v1.SalgsEnhedsPris);
            v1.RegistrerVarerSolgt(2, 20111002, v1.SalgsEnhedsPris);
            v1.SalgsEnhedsPris = 1.43f;
            v1.RegistrerVarerSolgt(3, 20111003, v1.SalgsEnhedsPris);
            v1.RegistrerVarerIndkbt(102, 20111012, 0.52f);
            v1.RegistrerVarerIndkbt(103, 20111023, 0.53f);
            IVare v2 = varekatalog.OpretVare(1002, "Skruer", 0, 2.4f);
            IVare v3 = varekatalog.OpretVare(1004, "A4 ternet", 0, 5.4f);
            v3.RegistrerVarerIndkbt(101, 20111001, 0.91f);
            v3.RegistrerVarerSolgt(1, 20111001, v1.SalgsEnhedsPris);
            v3.RegistrerVarerSolgt(2, 20111002, v1.SalgsEnhedsPris);
            v3.SalgsEnhedsPris = 1.01f;
            v3.RegistrerVarerSolgt(3, 20111003, v1.SalgsEnhedsPris);
            v3.RegistrerVarerIndkbt(102, 20111012, 0.52f);
            v3.RegistrerVarerIndkbt(103, 20111023, 0.53f);
        
        
        }

		// metode der udskriver en oversigt over alle varer i samlingen
        public static void UdskrivAlleVarer(IVarekatalog varekatalog)
		{
			List<IVare>  varesamling = varekatalog.GetAlleVarer();
			Console.WriteLine("Vare oversigt");
			foreach (IVare vare in varesamling)
			{
				UdskrivEnVare(vare);
			}
		}

		// metode der udskriver en enkelt vare, der angives som input-parameter
		public static void UdskrivEnVare (IVare vare)
		{
			Console.WriteLine("--------------------------------------------------");
			Console.WriteLine("Varenr: " + vare.Varenr);
			Console.WriteLine("Betegnelse: " + vare.Betegnelse);
			Console.WriteLine("Antal enheder p lager: " + vare.AntalPLager);
			Console.WriteLine("Salgsvrdi: " + vare.Salgsvrdi() );//NB: metodekald
			Console.WriteLine("Bevgelser");
			UdskrivBevaegelser (vare.GetBevgelser());
		}

		// metode der udskriver en enkelt vare, der angives som input-parameter
		public static void UdskrivBevaegelser (List<IVarebevaegelse> bevaegelser)
		{
			foreach (IVarebevaegelse bevaegelse in bevaegelser)
			{
				Console.WriteLine(bevaegelse.ToString());
			}
		}
	}
}
