using System;
using System.Collections.Generic;
using ModelInterfaces;

namespace ModelImplementation
{
	/* implementation af Varekatalog  */

	public class Varekatalog : IVarekatalog
	{
		private List<IVare> varer = new List<IVare>();

		public Varekatalog()
		{
		}

		

		public IVare OpretVare (int varenr, string betegnelse,	int antalPLager, float salgsEnhedsPris)
		{
			IVare nyVare = new Vare(varenr, betegnelse,antalPLager,salgsEnhedsPris);
			this.varer.Add(nyVare);
			return nyVare;
		}

		public List<IVare> GetAlleVarer ()
		{
			return new List<IVare>(this.varer);
		}

		public IVare FindVare (int varenr)
		{
			foreach (IVare enVare in this.varer)
			{
				if (enVare.Varenr == varenr)
					return enVare;	/*fundet*/
			}
			return null;	/*ikke fundet*/
		}


        public void OpretTestVarer()
        {
            IVare v1 = new Vare(1001,"Sm",0,1.4f);
            v1.RegistrerVarerIndkbt(101,20111001,0.51f);
            v1.RegistrerVarerSolgt(1, 20111001, v1.SalgsEnhedsPris);
            v1.RegistrerVarerSolgt(2, 20111002, v1.SalgsEnhedsPris);
            v1.SalgsEnhedsPris = 1.43f;
            v1.RegistrerVarerSolgt(3, 20111003, v1.SalgsEnhedsPris);
            v1.RegistrerVarerIndkbt(102, 20111012, 0.52f);
            v1.RegistrerVarerIndkbt(103,20111023, 0.53f);
            IVare v2 = new Vare(1002, "Skruer", 0, 2.4f);
            IVare v3 = new Vare(1004, "A4 ternet", 0, 5.4f);
            v1.RegistrerVarerIndkbt(101, 20111001, 0.91f);
            v1.RegistrerVarerSolgt(1, 20111001, v1.SalgsEnhedsPris);
            v1.RegistrerVarerSolgt(2, 20111002, v1.SalgsEnhedsPris);
            v1.SalgsEnhedsPris = 1.01f;
            v1.RegistrerVarerSolgt(3, 20111003, v1.SalgsEnhedsPris);
            v1.RegistrerVarerIndkbt(102, 20111012, 0.52f);
            v1.RegistrerVarerIndkbt(103, 20111023, 0.53f);
        }
    }
}
